// SuperproContainer.h: interface for the CSuperproContainer class.
//
//////////////////////////////////////////////////////////////////////
/***************************************************************************************
*SuperProContainer.h
*--------------------------------------------------------------------------------------
*
* Description - Header file for SuperProContainer Class
*
* Created By  - Jogender Chauhan.
*
* Purpose     - This Class is a wrapper Class for all the API supported by SuperPro.
*				SuperPro packet m_ApiPacket is the private data member, this packet
*				used to pass all the API. 
*				
* (C) Copyright 1991-2002 Rainbow Technologies, Inc. All rights reserved.
*-------------------------------------------------------------------------------------------
*
******************************************************************************************/

#if !defined(AFX_SUPERPROCONTAINER_H__AAB680CE_D724_4218_BE08_74AFDD35E68C__INCLUDED_)
#define AFX_SUPERPROCONTAINER_H__AAB680CE_D724_4218_BE08_74AFDD35E68C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "spromeps.h"

class CSuperproContainer  
{
public:
	SP_STATUS EnumServer(VARIANT enumflag, VARIANT developerId, NSPRO_SERVER_INFO *pServersInfoRecord, VARIANT *pNumOfServers);
	SP_STATUS GetKeyInfo(VARIANT developerId, VARIANT keyIndex, NSPRO_MONITOR_INFO *pBufferInfo);
	SP_STATUS Query(VARIANT address, VARIANT queryData, VARIANT *pResponse, VARIANT *pResponse32, VARIANT length);
	SP_STATUS SetProtocol(VARIANT protocol);
	SP_STATUS ExtendedRead(VARIANT address, VARIANT *pData, VARIANT *pAccessCode);
	static wchar_t * MBCSToWideChar(const char *mbcsString);
	SP_STATUS FindNextUnit();
	SP_STATUS Write(VARIANT writePassword, VARIANT address, VARIANT data, VARIANT accessCode);
	SP_STATUS SetHeartBeat(VARIANT heartBeatValue);
	SP_STATUS ReleaseLicense(VARIANT address, VARIANT *pNumOfLicense);
	SP_STATUS Read(VARIANT address, VARIANT *pData);
	SP_STATUS Overwrite(VARIANT writePassword, VARIANT owp1, VARIANT owp2, VARIANT address, VARIANT data, VARIANT accessCode);
	SP_STATUS GetSubLicense(VARIANT address);
	SP_STATUS GetHardLimit(VARIANT *pHardLimit);
	SP_STATUS GetFullStatus();
	SP_STATUS GetContactServer(VARIANT *pServerName);
	SP_STATUS Activate(VARIANT writePassword, VARIANT activatepw1, VARIANT activatepw2, VARIANT address);
	SP_STATUS Decrement(VARIANT writePassword, VARIANT address);
	SP_STATUS SetContactServer(VARIANT serverName);
	SP_STATUS GetVersion(VARIANT *pMajor, VARIANT *pMinor, VARIANT *pRev, VARIANT *pOsType);
	SP_STATUS Initialize();
	static char * WideCharToMBCS(wchar_t *wString);
	SP_STATUS FindFirstUnit(VARIANT developerId);
	SP_STATUS FormatPacket();
	CSuperproContainer();
	virtual ~CSuperproContainer();

private:
	unsigned char MakeHexChar(unsigned char num);
	unsigned char HexCharToDigit(char hexChar);
	void ConvertResponseStr(char *responseStr, char *disResponseStr, int len);
	void ConvertQueryStr(char *queryStr, char *realQueryStr);
	int StrToHex(const char *value);
	RB_SPRO_APIPACKET m_ApiPacket;
};

#endif // !defined(AFX_SUPERPROCONTAINER_H__AAB680CE_D724_4218_BE08_74AFDD35E68C__INCLUDED_)
