Attribute VB_Name = "spromeps"
' (C) Copyright 1991-2002 Rainbow Technologies, Inc. All rights reserved.

DefLng A-Z
'constants required for SetProtocol
Global Const NSPRO_TCP_PROTOCOL = 1
Global Const NSPRO_IPX_PROTOCOL = 2
Global Const NSPRO_NETBEUI_PROTOCOL = 4
Global Const NSPRO_SAP_PROTOCOL = 8

'constants required for Enum Flag
Global Const NSPRO_RET_ON_FIRST = 1
Global Const NSPRO_GET_ALL_SERVERS = 2
Global Const NSPRO_RET_ON_FIRST_AVAILABLE = 4

'constants required for HeartBeat
Global Const MAX_HEARTBEAT = 2592000
Global Const MIN_HEARTBEAT = 60
Global Const INFINITE_HEARTBEAT = &HFFFFFFFF

'constants required for showing OS driver type
Global Const RB_WINNT_SYS_DRVR = 5 ' Windows NT system driver
Global Const RB_WIN95_SYS_DRVR = 7  'Windows 95 system driver
Global Const RB_NW_LOCAL_DRVR = 8  'Netware local driver

'constants required for SetContactServer API
Global Const RNBO_STANDALONE = "RNBO_STANDALONE"
Global Const RNBO_SPN_DRIVER = "RNBO_SPN_DRIVER"
Global Const RNBO_SPN_LOCAL = "RNBO_SPN_LOCAL"
Global Const RNBO_SPN_BROADCAST = "RNBO_SPN_BROADCAST"
Global Const RNBO_SPN_ALL_MODES = "RNBO_SPN_ALL_MODES"
Global Const RNBO_SPN_SERVER_MODES = "RNBO_SPN_SERVER_MODES"

'Global constants required for some fixed values
Global Const MAX_NAME_LEN = 64
Global Const MAX_ADDR_LEN = 32
Global Const API_PACKET_SZ = 4112
Global Const MAX_NUM_SERVERS = 10
Global Const MAX_QUERY_LEN = 56
Global Const MIN_QUERY_LEN = 8
Global Const MIN_ACCESS_CODE = 0
Global Const MAX_ACCESS_CODE = 3
Global Const MAX_CELL_DATA_LEN = 4
Global Const MAX_CELL_ADD_LEN = 2


'some global constants
Global XreadD, wPass, oPass1, oPass2, Datum, dID
Global XreadAcc%, aCode%, Data%, ProtocolFlag%
Global valid$, nl$
Global IsInitialized As Byte 'will tell whether the apipkt is initialized or not
Global errFlag As Integer ' the global error flag

'Declare the SuperPro COM object
Global SSPObj As RAINBOWSSPLib.Superpro


Public Function ToHex(arg As String, Optional maxLen As Integer, Optional msgStr As String, Optional titleStr As String) As Long
    errFlag% = 0 'initialize the flag to "NO ERROR" mode
    arg = UCase(arg) 'CAPitalize it
    ln% = Len(arg)     'scan entire string
    If (maxLen) Then
        If ln% > maxLen Then
           MsgBox msgStr & " must be in hex with length not exceeding " & maxLen & " chars.", 0, titleStr
           errFlag% = -1
           Exit Function
        End If
    End If
    
    i% = ln%
    While i% > 0        'backwards for hex chars, blanks
        h$ = Mid$(arg$, i%, 1) '1-at-a-time
        If InStr(valid$, h$) = 0 Then errFlag% = 1 'non-hex
        If h$ = " " Then
            arg$ = Left$(arg$, i% - 1) + Right$(arg$, i% - 1)
            ln% = ln% - 1
        End If
        i% = i% - 1
    Wend
    '
    If errFlag% = 1 Then Adr = -1    'return err flag if problem
    If errFlag% = 0 And ln% > 0 Then
        For i% = 1 To ln%     'compute dec. addr. from hex digit
            t% = InStr(valid$, Mid$(arg$, i%, 1))   'next digit
            Adr = Adr * 16 + t% - 1 'make room for newest digit
        Next i%
    End If
    ToHex = Adr
    'input of 'FFFF' results in dec. value of 65535
    'BUT, we cannot take HEX$(no.>32767)
End Function

Public Function IntegerToUnsigned(Value As Integer) As Long
    'The function takes an unsigned Integer from and API and
    'converts it to a Long for display or arithmetic purposes
    If Value < 0 Then
        IntegerToUnsigned = Value + 65536 'the limit of unsigned int in C is 65535
    Else
        IntegerToUnsigned = Value
    End If
    '
End Function

Public Function ErrorPresent(invalidStr As String, title As String, maxLen As Integer) As Integer
   ErrorPresent = 1 'set the functions return value
    If errFlag% = 1 Then 'check if error flag has been set by the subroutine "getchars"
       MsgBox invalidStr + " must be hex with length not exceeding " + CStr(maxLen) + " digits.", vbOKOnly, title
       Exit Function
    ElseIf errFlag% = -1 Then 'user has not enterd any INPUT or has pressed cancel
'       ErrorPresent = 2
       Exit Function
    End If
    ErrorPresent = 0
End Function



